// ManageFabricModifyPage.js


//////////////////////////////////////// SHELL /////////////////////////////////////////////
function initializeShell()
{
	resizeFrameHeight('staticLoadingFrame', 'staticLoadingFrame'); 
	resizeFrameWidth('staticLoadingFrame', 'staticLoadingFrame');
}

function startShellLoading()
{
	document.getElementById('staticLoadingDiv').style.display='block'; 
	document.getElementById('dynamicDiv').style.visibility='hidden';
	
	// Make the dynamic frame very small
	document.getElementById('dynamicFrame').style.width = "1px";
	document.getElementById('dynamicFrame').style.height = "1px";

	resizeFrameHeight('staticLoadingFrame', 'staticLoadingFrame');
}

function stopShellLoading()
{
	document.getElementById('staticLoadingDiv').style.display='none'; 
	document.getElementById('dynamicDiv').style.visibility='visible';
	
	resizeFrameHeight("dynamicFrame", "dynamicFrame");
}

/////////////////////////////////////////////////////////////////////////////////////

// so the user does not get the "are you sure" message when saving (they already confirm those)
var alreadyConfirmed = false;
var saveDisabled = false;
var whiteSpace = " ";

window.onbeforeunload = confirmBrowseAway;

function confirmBrowseAway()
{  
	if (self.editorFrame && self.editorFrame.getHasBeenModified() && !alreadyConfirmed) 
	{    
		// The NLS message is stored in a hidden input field
		return document.getElementById(namespace_g+"hiddenForm:navigateAwayNLSMessage").value; 
	}
}

function saveAs()
{
	var selectedIndex = document.getElementById("saveAsModalForm:nonCannedConfigurationIndexMenu").value;
	// Check if they selected the active index
	if(activeIndex == selectedIndex)
	{
		document.getElementById("saveAsEqualsActive").style.display = "block";
	}
	else
	{
		document.getElementById("saveAsEqualsActive").style.display = "none";
	}
	
	document.getElementById("saveAsIndex").innerHTML = selectedIndex + whiteSpace;
	document.getElementById("saveAsModalForm:selectedIndex").value = selectedIndex;
}

function clearConfig()
{
	window.frames['editorFrame'].clear();
}

function limitInput(element, max)
{
	if(element.value.length > max)
	{
		element.value = element.value.substring(0, max);	
	}
}

function disableControlButtons()
{
	// Control buttons need to be disabled until the editor frame is finished loading
	
	// Saving the old value (just in case its always disabled due to a canned config)
	saveDisabled = document.getElementById(namespace_g+"cancelForm:saveButton").disabled;
	
	document.getElementById(namespace_g+"cancelForm:saveButton").disabled = true;
	document.getElementById(namespace_g+"cancelForm:saveAsButton").disabled = true;
	document.getElementById(namespace_g+"cancelForm:mainCancel").disabled = true;
	document.getElementById(namespace_g+"clearConfigurationButton").disabled = true;
}

function editorFrameLoaded()
{
	// Hide loading div
	document.getElementById("editorLoadingDiv").style.display = "none";	
	
	// Restore initial value for save button
	document.getElementById(namespace_g+"cancelForm:saveButton").disabled = saveDisabled;
	
	document.getElementById(namespace_g+"cancelForm:saveAsButton").disabled = false;
	document.getElementById(namespace_g+"cancelForm:mainCancel").disabled = false;
	document.getElementById(namespace_g+"clearConfigurationButton").disabled = false;
}

function includeMappings()
{
	// A function that can be used to include the current state of the editor frame on the page
	
	// Get the mappings from the editor frame, and include them in the information
	// in hidden inputs on the page so that is sent to the server
	var mappings = window.frames['editorFrame'].getMappings();
	
	container = document.getElementById(namespace_g+"mappingsDiv");
	
	// Clear the contents
	container.innerHTML = "";
	
	for(x = 0; x < mappings.length; x++)
	{
		var newHiddenInput = document.createElement("input");
		
		newHiddenInput.setAttribute("type", "hidden");
		newHiddenInput.setAttribute("name", "mappings");
		// NOTE: this string will be tokenized using the ' maps to ' string, to parse out the source and destination ID
		newHiddenInput.setAttribute("value", mappings[x][0] + " maps to " + mappings[x][1]);
			
		container.appendChild(newHiddenInput);
	}
}

function submitForm(theObj,submitBtnId,cancelBtnId){
  theObj.disabled = true;
  if(cancelBtnId!=null){
  	document.getElementById(namespace_g+cancelBtnId).disabled = true;
  }
  if(submitBtnId!=null){ 
  	document.getElementById(namespace_g+submitBtnId).click();
  }
}
function saveModalOnshow(){
		document.getElementById(namespace_g+"saveModalForm:saveCfgError").style.display="none";
}
function saveAsModalOnshow(){
		document.getElementById(namespace_g+"saveAsModalForm:saveAsCfgError").style.display="none";
}
var nameRegex = new RegExp("[^<>'\"&%/]*");
function validationSaveCfgInput(){
	var nickName = document.getElementById(namespace_g+"saveModalForm:saveModalConfigurationNickname").value;
	var description = document.getElementById(namespace_g+"saveModalForm:saveModalConfigurationDescription").value;
	if(nickName != nickName.match(nameRegex)){
		document.getElementById(namespace_g+"saveModalForm:saveCfgDescError").style.display="none";
		document.getElementById(namespace_g+"saveModalForm:saveCfgError").style.display="";
		return false;
	}else{
		document.getElementById(namespace_g+"saveModalForm:saveCfgError").style.display="none";
	}
	if(description != description.match(nameRegex)){
		document.getElementById(namespace_g+"saveModalForm:saveCfgDescError").style.display="";
		return false;
	}else {
		document.getElementById(namespace_g+"saveModalForm:saveCfgDescError").style.display="none";
	}
	return true;
}
function validationSaveAsCfgInput(){
	var nickName = document.getElementById(namespace_g+"saveAsModalForm:saveAsModalConfigurationNickname").value;
	var description = document.getElementById(namespace_g+"saveAsModalForm:saveAsModalConfigurationDescription").value;
	if(nickName != nickName.match(nameRegex)){
		document.getElementById(namespace_g+"saveAsModalForm:saveAsCfgError").style.display="";
		document.getElementById(namespace_g+"saveAsModalForm:saveAsCfgDescError").style.display="none";
		return false;
	}else{
		document.getElementById(namespace_g+"saveAsModalForm:saveAsCfgError").style.display="none";
	}
	if(description != description.match(nameRegex)){
		document.getElementById(namespace_g+"saveAsModalForm:saveAsCfgDescError").style.display="";
		return false;
	}else{
		document.getElementById(namespace_g+"saveAsModalForm:saveAsCfgDescError").style.display="none";
	}
	saveAs();
	return true;
}