//############################################ Begin of JS functions for stand alone preverify #############################################################
var PREVERIFY_STATES = {
	IN_PROGRESS:"1",UPLOAD:"2",PREVERIFY_SUCCESS:"3",PREVERIFY_FAIL:"4"
}

function onLoad_PrepareUpdateFirmware()
{
	initErrorMessage();
	if(isInProgress())
	{
		firmware_showPreverifyState(PREVERIFY_STATES.IN_PROGRESS);
		firmware_disablePreverifyPageComponents(true);
		setTimeout(pollingPreverifyResult,200);
	}
}

function changePrepareUpdateFirmwareDeviceList()
{
	document.getElementById(namespace_g + "myForm").target = "_self";
	document.getElementById(namespace_g + "myForm").submit();
}

function firmware_preverify()
{
	var infoMsg = document.getElementById(namespace_g + "myForm:informationMessage").innerHTML;
	//check firmware bundle	
	var obj = document.getElementById(namespace_g+ "myForm:fileupload1");
	var filename = obj.value;
	if(filename.indexOf(".")>0)
	{
		//clear message, disable button and show in progress
		clearAllInnMessages();
		document.getElementById(namespace_g + "myForm:preverifyFakeBtn").disabled=true;	
		firmware_showPreverifyState(PREVERIFY_STATES.UPLOAD);
		document.getElementById(namespace_g+'myForm:submitFormBtn').click();
	}		
	else
	{
		if(filename.length > 0 ) {
			document.getElementById(namespace_g + "myForm:alert_text").innerHTML = document.getElementById(namespace_g + "myForm:hiddenInstallInvalidat").innerHTML;	   
			document.getElementById(namespace_g + "myForm:alert_dialog_tb").lastChild.nodeValue = infoMsg;
			document.getElementById(namespace_g + "myForm:showAlertDialogBtn").click();
		}
		else {	
			document.getElementById(namespace_g + "myForm:alert_text").innerHTML = document.getElementById(namespace_g + "myForm:hiddenInstallAlert").innerHTML;		   
			document.getElementById(namespace_g + "myForm:alert_dialog_tb").lastChild.nodeValue = infoMsg;
			document.getElementById(namespace_g + "myForm:showAlertDialogBtn").click();
		}
		return;
	}
}

function firmware_preverifyBtnClick(){
	clearAllInnMessages();
	firmware_disablePreverifyPageComponents(true);
	firmware_showPreverifyState(PREVERIFY_STATES.IN_PROGRESS);
	if (parent){
		parent.resizeFrameHeight("dynamicFrame", "dynamicFrame");
	}
}

//flag is used to control radiogroup, preverify button display. If flag is true, disable all these components
function firmware_disablePreverifyPageComponents(flag){
	if(flag){
		//Enable upload file, preverify button and select mode component
		document.getElementById(namespace_g + "myForm:preverifyFakeBtn").disabled=true;
		var selectItems = document.getElementsByName(namespace_g + "myForm:preverify_updatefirmware_type_radio");
		for(var i=0;i<selectItems.length;i++)
		{
			if(selectItems[i].type == "radio")
				selectItems[i].disabled = true;
		}
		document.getElementById(namespace_g + "myForm:fileupload1").disabled = true;
	}else{
		//Enable upload file, preverify button and select mode component
		document.getElementById(namespace_g + "myForm:preverifyFakeBtn").disabled=false;
		var selectItems = document.getElementsByName(namespace_g + "myForm:preverify_updatefirmware_type_radio");
		for(var i=0;i<selectItems.length;i++)
		{
			if(selectItems[i].type == "radio")
				selectItems[i].disabled = false;
		}
		document.getElementById(namespace_g + "myForm:fileupload1").disabled = false;
	}
}

function firmware_showPreverifyState(state){
	switch (state) {
		case PREVERIFY_STATES.IN_PROGRESS:
			//Show the image for preverify in progress.
			document.getElementById(namespace_g + "myForm:preverifying_img").style.display = "";
			document.getElementById(namespace_g + "myForm:Normal_img").style.display = "none";
			document.getElementById(namespace_g + "myForm:Failure_img").style.display = "none";
			//Show the state for preverify in progress.
			document.getElementById(namespace_g + "myForm:textUpload").style.display = "none";
			document.getElementById(namespace_g + "myForm:textInprogress").style.display = "";
			document.getElementById(namespace_g + "myForm:textReadyState").style.display = "none";
			document.getElementById(namespace_g + "myForm:textNotReadyState").style.display = "none";
			//Hide the last preverify time info
			document.getElementById(namespace_g + "myForm:lastPreverifyLabel").style.display = "none";
			document.getElementById(namespace_g + "myForm:lastPreverifyDate").innerHTML =""; 
			document.getElementById(namespace_g + "myForm:lastPreverifyDate").style.display = "none";
			break;
		case PREVERIFY_STATES.UPLOAD:
			//Show the image for preverify upload.
			document.getElementById(namespace_g + "myForm:preverifying_img").style.display = "";
			document.getElementById(namespace_g + "myForm:Normal_img").style.display = "none";
			document.getElementById(namespace_g + "myForm:Failure_img").style.display = "none";
			//Show the state for preverify upload.
			document.getElementById(namespace_g + "myForm:textUpload").style.display = "";
			document.getElementById(namespace_g + "myForm:textInprogress").style.display = "none";
			document.getElementById(namespace_g + "myForm:textReadyState").style.display = "none";
			document.getElementById(namespace_g + "myForm:textNotReadyState").style.display = "none";
			//Hide the last preverify time info
			document.getElementById(namespace_g + "myForm:lastPreverifyLabel").style.display = "none";
			document.getElementById(namespace_g + "myForm:lastPreverifyDate").innerHTML =""; 
			document.getElementById(namespace_g + "myForm:lastPreverifyDate").style.display = "none";
			break;
		case PREVERIFY_STATES.PREVERIFY_SUCCESS:
			//show the image for preverify succeeded.
			document.getElementById(namespace_g + "myForm:preverifying_img").style.display = "none";
			document.getElementById(namespace_g + "myForm:Normal_img").style.display = "";
			document.getElementById(namespace_g + "myForm:Failure_img").style.display = "none";
			//show the state for preverify succeeded.
			document.getElementById(namespace_g + "myForm:textInprogress").style.display = "none";
			document.getElementById(namespace_g + "myForm:textUpload").style.display = "none";
			document.getElementById(namespace_g + "myForm:textReadyState").style.display = "";
			document.getElementById(namespace_g + "myForm:textNotReadyState").style.display = "none";
			//Show the last preverify time info
			document.getElementById(namespace_g + "myForm:lastPreverifyLabel").style.display = "";
			var preverifyMilliSeconds = document.getElementById(namespace_g + "myForm:PreverifyMillisSeconds");
			document.getElementById(namespace_g + "myForm:lastPreverifyDate").innerHTML = getLocalizedTimeStamp(preverifyMilliSeconds.innerHTML); 
			document.getElementById(namespace_g + "myForm:lastPreverifyDate").style.display = "";
			break;
		case PREVERIFY_STATES.PREVERIFY_FAIL:
			//show the image for preverify failed.
			document.getElementById(namespace_g + "myForm:preverifying_img").style.display = "none";
			document.getElementById(namespace_g + "myForm:Normal_img").style.display = "none";
			document.getElementById(namespace_g + "myForm:Failure_img").style.display = "";
			//show the state for preverify failed.
			document.getElementById(namespace_g + "myForm:textInprogress").style.display = "none";
			document.getElementById(namespace_g + "myForm:textUpload").style.display = "none";
			document.getElementById(namespace_g + "myForm:textReadyState").style.display = "none";
			document.getElementById(namespace_g + "myForm:textNotReadyState").style.display = "";
			//Show the last preverify time info
			document.getElementById(namespace_g + "myForm:lastPreverifyLabel").style.display = "";
			var preverifyMilliSeconds = document.getElementById(namespace_g + "myForm:PreverifyMillisSeconds");
			document.getElementById(namespace_g + "myForm:lastPreverifyDate").innerHTML = getLocalizedTimeStamp(preverifyMilliSeconds.innerHTML); 
			document.getElementById(namespace_g + "myForm:lastPreverifyDate").style.display = "";
			break;
	}
	if(parent){
		parent.resizeFrameHeight('dynamicFrame', 'dynamicFrame');
	}
}
function firmware_preverifyFinish(){
	beepWhenRefresh();
	firmware_disablePreverifyPageComponents(false);
	firmware_showPreverifyState("true" == document.getElementById(namespace_g + "myForm:PreverifyResult").innerHTML?PREVERIFY_STATES.PREVERIFY_SUCCESS:PREVERIFY_STATES.PREVERIFY_FAIL);
	innerMessagesInstance.display();
}

function isInProgress()
{
	if("true" == document.getElementById(namespace_g + "myForm:progressIndiator").innerHTML)
	{
		return true;
	}
	else
	{
		return false;
	}
}

function pollingPreverifyResult()
{
	document.getElementById(namespace_g + "myForm:pollPreverifyResultBtn").click();
}
//############################################ End of JS functions for stand alone preverify #############################################################