/**
*	static variables declaration
*/
var img_host_small = document.global_context_path + "/images/entity/blade_16.gif";
var img_host_large = document.global_context_path + "/images/drivehostcontroller/blade_for_mapping.gif";
var img_volume_small = document.global_context_path + "/images/drivehostcontroller/volume_icon.gif";
var img_volume_large = document.global_context_path + "/images/drivehostcontroller/volume_not_mapped.gif";
var MAX_HOSTS_NUMBER = 6;
var MAX_VOLUMES_PER_HOST = 16;
var UNMAPPED_VOLUME_TYPE_INDEX = 1;
/**
*data model for both host and volume
*@parameter:
*		identify: the unique id of the item object
*		name: the display name of the item
*		selected:flag whether the item is selected
**/
var Item = function(identify,name){
   this.identify = identify;
   this.name = name;
   this.selected = false;
   this.GB = "";
   this.LUN = "";
}
/**
*data model for store host and hidden mapped volumes
**/
function Map() {

	this.elements = new Array();

	this.size = function() {
		return this.elements.length;
	}

	this.isEmpty = function() {
		return (this.elements.length < 1);
	}

	this.clear = function() {
		this.elements = new Array();
	}

	this.put = function(_key, _value) {
		this.elements.push({key:_key, value:_value});
	}

	this.get = function(_key) {
		try{
			for (i = 0; i < this.elements.length; i++) {
				if (this.elements[i].key == _key) {
					return this.elements[i].value;
				}
			}
		}catch(e) {
			return null;
		}
	}

	this.element = function(_index) {
		if (_index < 0 || _index >= this.elements.length) {
			return null;
		}
		return this.elements[_index];
	}

	this.values = function() {
		var arr = new Array();
		for (i = 0; i < this.elements.length; i++) {
			arr.push(this.elements[i].value);
		}
		return arr;
	}

	this.keys = function() {
		var arr = new Array();
		for (i = 0; i < this.elements.length; i++) {
			arr.push(this.elements[i].key);
		}
		return arr;
	}
}

//declare the variables for whole page
var inWizard = false;
var hostArray = new Array();		//variable to keep all host items
var selectedHostIDs = new Array();	//variable to keep the selected host item's IDs
var selectedHostIndexes=new Array();//variable to keep the selected host item's indexes in the hosts array;
var volumeArray = new Array();		//variable to keep all volume items
var selectedVolumeIDs = new Array();//variable to keep the selected volume items' IDs
var volumeTypes = new Array();		//variable to keep the array of volume filter types;
var volMapArray = new Array(); 		//variable to keep the array of mapping info between filter condition and an array of volumes
var aVolumeList = new Array();		//variable to cache a array of volume item
var aVolume;						//variable to cash a volume item
var aHost;							//variable to cash a host item
var hostVolMapArray = new Array();	//variable to keep the array of mapping info between host and volumes
var req;							//ajax request object;
var currFilter = "";				//variable to keep current volume Filter option;
var definedVolumeArray = new Array();//variable to keep the array of volume items defined in wizard;
var preSelectedHostID = "";
var hostVolumeMap = new Map();		//variable to store hidden mapped volumes for each host
/**
*data model to keep the mapping info between a filter condition and an array of volumes
*@parameter:
*		keyFilter:volume filter condition;
*		volumes:array of volume item objects
**/
var volMapItem = function(keyFilter,volumes){
	this.keyFilter = keyFilter;
	this.volumes = volumes;
	this.isVolumeMapped = function(volumeId){
		if (null != this.volumes) {
			for (var i = 0; i < this.volumes.length; i++) {
				if (volumeId == this.volumes[i].identify) {
					return true;
				}
			}
		}
		else {
			return false;
		}
	}
}
/**
*data model to keep the mapping info between a host and an array of volumes
*@parameter:
*		hostItem:host item;
*		volumeItemArray:array of volume item objects
**/
var hostVolMapItem = function(hostItem,volumeItemArray){
	this.hostItem = hostItem;
	this.volumeItemArray = volumeItemArray;
	this.isVolumeMapped = function(volumeId){
		if(null!=this.volumeItemArray){
			for(var i=0;i<this.volumeItemArray.length;i++){
				if(volumeId == this.volumeItemArray[i].identify){
					return true;
				}
			}
		}else{
			return false;
		}
	}
}

function initHostArrayFromHTML(){
	hostArray = new Array();
	selectedHostIndexes = new Array();
	selectedHostIDs = new Array();
	
	var hostsSet = document.getElementById("hostsSet");
	var hostChildNodes = hostsSet.childNodes;	

	for(var i=0;i<hostChildNodes.length;i++){		
		if("TABLE" == hostChildNodes[i].tagName){		
			hostArray[hostArray.length] = new Item(hostChildNodes[i].id,hostChildNodes[i].attributes.getNamedItem("name").value);					
		}
	}
	if(1==hostArray.length){		
		document.getElementById(hostArray[0].identify).onclick();		
	}
	if(MAX_HOSTS_NUMBER>hostArray.length){
		document.getElementById(namespace_g + "myForm:discoverHostBtn").disabled=false;
	}else{
		document.getElementById(namespace_g + "myForm:discoverHostBtn").disabled=true;
	}
	dispHostImgBorder();
}
function initVolumeArrayFromHTML(){
	volumeArray = new Array();
	selectedVolumeIDs = new Array();
	
	
	var volumesSet = document.getElementById("volumesSet");
	var volumesChildNodes = volumesSet.childNodes;	
	for(var i=0;i<volumesChildNodes.length;i++){
		if("TABLE" == volumesChildNodes[i].tagName){				
			aVolume = new Item(volumesChildNodes[i].id,volumesChildNodes[i].attributes.getNamedItem("name").value);	
			aVolume.GB = volumesChildNodes[i].attributes.getNamedItem("Capcity").value;
			aVolume.LUN = volumesChildNodes[i].attributes.getNamedItem("LUNNumber").value;
			volumeArray[volumeArray.length] = aVolume;						
		}
	}
	if(1==volumeArray.length){
		document.getElementById(volumeArray[0].identify).onclick();		
	}
	dispVolumeImgBorder();
}

function clickHost(_hostImgID){    
   for(var i=0;i<hostArray.length;i++){	   
	    if(_hostImgID == hostArray[i].identify){		  
			hostArray[i].selected=!(hostArray[i].selected);	
			if(hostArray[i].selected){
				selectedHostIDs.push(hostArray[i].identify);
				selectedHostIndexes.push(i);
			}else{
			    for(var j=0;j<selectedHostIDs.length;j++){
					if(selectedHostIDs[j]==_hostImgID){
						selectedHostIDs.splice(j,1);
						selectedHostIndexes.splice(j,1);
					}
				}
			}
			break;
		}
	}
	dispHostImgBorder();
	changeMapBtnStatus();
}

function dispHostImgBorder(){
    for(var i=0;i<hostArray.length;i++){
	    var _item = hostArray[i];
	    if(_item.selected){
            document.getElementById(_item.identify).style.borderColor="orange";
            document.getElementById(_item.identify).title=document.getElementById(namespace_g + "myForm:hostHover").innerHTML +" "+ _item.name 
					   +" " +document.getElementById(namespace_g + "myForm:itemChecked").innerHTML;
		    document.getElementById(_item.identify+"imgID").title=document.getElementById(namespace_g + "myForm:hostHover").innerHTML +" "+ _item.name 
					   +" " +document.getElementById(namespace_g + "myForm:itemChecked").innerHTML;
            document.getElementById(_item.identify+"imgID").alt=document.getElementById(namespace_g + "myForm:hostHover").innerHTML +" "+ _item.name 
					   +" " +document.getElementById(namespace_g + "myForm:itemChecked").innerHTML;
        }	   
	    else{
	        document.getElementById(_item.identify).style.borderColor="#ffffff";
	        document.getElementById(_item.identify).title=document.getElementById(namespace_g + "myForm:hostHover").innerHTML +" "+ _item.name 
					   +" " +document.getElementById(namespace_g + "myForm:itemNotChecked").innerHTML;
			document.getElementById(_item.identify+"imgID").title=document.getElementById(namespace_g + "myForm:hostHover").innerHTML +" "+ _item.name 
					   +" " +document.getElementById(namespace_g + "myForm:itemNotChecked").innerHTML;
	        document.getElementById(_item.identify+"imgID").alt=document.getElementById(namespace_g + "myForm:hostHover").innerHTML +" "+ _item.name 
					   +" " +document.getElementById(namespace_g + "myForm:itemNotChecked").innerHTML;
	    }
	}
}

function clickVolume(_volumeImgID){    
    for(var i=0;i<volumeArray.length;i++){	   
	    if(_volumeImgID == volumeArray[i].identify){		  
			volumeArray[i].selected=!(volumeArray[i].selected);	
			if(volumeArray[i].selected){
				selectedVolumeIDs.push(volumeArray[i].identify);
			}else{
			    for(var j=0;j<selectedVolumeIDs.length;j++){
					if(selectedVolumeIDs[j]==_volumeImgID){
						selectedVolumeIDs.splice(j,1);
					}
				}
			}
			break;
		}
	}
	dispVolumeImgBorder();
	changeMapBtnStatus();
}

function dispVolumeImgBorder(){
	for(var i=0;i<volumeArray.length;i++){
	    var _item = volumeArray[i];
	    if(_item.selected){
            document.getElementById(_item.identify).style.borderColor="orange";
            document.getElementById(_item.identify).title=document.getElementById(namespace_g + "myForm:volumeHover").innerHTML +" "+ _item.name 
					   +" " +document.getElementById(namespace_g + "myForm:itemChecked").innerHTML;
			document.getElementById(_item.identify+"imgID").title=document.getElementById(namespace_g + "myForm:volumeHover").innerHTML +" "+ _item.name 
					   +" " +document.getElementById(namespace_g + "myForm:itemChecked").innerHTML;
            document.getElementById(_item.identify+"imgID").alt=document.getElementById(namespace_g + "myForm:volumeHover").innerHTML +" "+ _item.name 
					   +" " +document.getElementById(namespace_g + "myForm:itemChecked").innerHTML;
        }	   
	    else{
	        document.getElementById(_item.identify).style.borderColor="#ffffff";
	        document.getElementById(_item.identify).title=document.getElementById(namespace_g + "myForm:volumeHover").innerHTML +" "+ _item.name 
					   +" " +document.getElementById(namespace_g + "myForm:itemNotChecked").innerHTML;
			document.getElementById(_item.identify+"imgID").title=document.getElementById(namespace_g + "myForm:volumeHover").innerHTML +" "+ _item.name 
					   +" " +document.getElementById(namespace_g + "myForm:itemNotChecked").innerHTML;
	        document.getElementById(_item.identify+"imgID").alt=document.getElementById(namespace_g + "myForm:volumeHover").innerHTML +" "+ _item.name 
					   +" " +document.getElementById(namespace_g + "myForm:itemNotChecked").innerHTML;
	    }
	}
}

function changeMapBtnStatus(){
	if(0<selectedHostIDs.length && 0<selectedVolumeIDs.length){
		document.getElementById(namespace_g + "myForm:mapVolumeBtn").disabled=false;
	}else{
		document.getElementById(namespace_g + "myForm:mapVolumeBtn").disabled=true;
	}
}

function filterChange(){
	var currVolList=getCurrVolList();

	//redraw "volumesSet" 
	redrawVolumesSet(currVolList);
	
	//reInit volumeArray
	initVolumeArrayFromHTML();
	
	changeMapBtnStatus();
}

function getCurrFilterIndex(){
	var currFilter = document.getElementById("volumeFilter").value;
	for(var i=0;i<volMapArray.length;i++){
		if(currFilter == volMapArray[i].keyFilter){
			return i;
		}
	}
}

function getCurrVolList(){
	var currFilter = document.getElementById("volumeFilter").value;
	var currVolList;

	//get the volumes according to the filter 
	for(var i=0;i<volMapArray.length;i++){
		if(currFilter == volMapArray[i].keyFilter){
			return volMapArray[i].volumes;
		}
	}
	return []; // to avoid null error, added by yaofeng
}

function genVolumeFilterOptions(){
	var volFilter = document.getElementById("volumeFilter");
	for(var i=0;i<volumeTypes.length;i++){
		volFilter.options[i] = new Option(volumeTypes[i],i);
	}
	volFilter.value=currFilter;
}

//defect cq 11150
function handleKeyInHostsSet(event,obj){
    if(event.keyCode==32){
        clickHost(obj);
    }
}
function handleKeyInVolumesSet(event,obj){
    if(event.keyCode==32){
        clickVolume(obj);
    }
}

function redrawHostsSet(){
	var hostsSet = document.getElementById("hostsSet");
	var strHTML = "";	
	if(0<hostVolMapArray.length){
		for(var i=0;i<hostVolMapArray.length;i++){
			var currHost = hostVolMapArray[i].hostItem;
			strHTML += "<table bordercolor='#ffffff' style='border:solid 2px'  class='dmc_rowClass1' " 
					   +" cellspacing='0' cellpadding='0' id='"
					   +currHost.identify+"' name='"+currHost.name
					   +"'onkeyup='handleKeyInHostsSet(event,\""+currHost.identify
					   +"\")' onclick='clickHost(\""+currHost.identify
					   +"\")' title='"
					   +document.getElementById(namespace_g + "myForm:hostHover").innerHTML +" "+ currHost.name 
					   +" " +document.getElementById(namespace_g + "myForm:itemNotChecked").innerHTML
					   +"'><tr><td align='center' tabindex='0'><img id='"+currHost.identify+"imgID' src='"+img_host_large +"' alt='"
					   +document.getElementById(namespace_g + "myForm:hostHover").innerHTML+" "+currHost.name 
					   +" " +document.getElementById(namespace_g + "myForm:itemNotChecked").innerHTML+"' title='"
					   +document.getElementById(namespace_g + "myForm:hostHover").innerHTML +" "+currHost.name 
					   +" " +document.getElementById(namespace_g + "myForm:itemNotChecked").innerHTML+"'>"
					   +"<BR/><span class='dmc_outputText' style='white-space:nowrap' title='"
					   +document.getElementById(namespace_g + "myForm:hostHover").innerHTML+" "+currHost.name+"'>"
					   +currHost.name+"</span></td></tr></table><BR/>";
		}
	}else{
		strHTML = document.getElementById(namespace_g + "myForm:noHostMessage").innerHTML;
	}
	hostsSet.innerHTML = strHTML;

}

function redrawVolumesSet(currVolList){
	var volumesSet = document.getElementById("volumesSet");
	var strHTML = "";
	for(var i=0;i<currVolList.length;i++){
		var currVolume = currVolList[i];
		strHTML +="<table bordercolor='#FFFFFF' style='border:solid 2px' class='dmc_rowClass1' "
					+"cellspacing='0' cellpadding='0' id='"+currVolume.identify
					+"' name='"+currVolume.name+"' Capcity='"
					+currVolume.GB+"' LUNNumber='"+currVolume.LUN
					+"'onkeyup='handleKeyInVolumesSet(event,\""+currVolume.identify
					+"\")' onclick='clickVolume(\""
					+currVolume.identify+"\")' title='"
					+document.getElementById(namespace_g + "myForm:volumeHover").innerHTML +" "+ currVolume.name 
					+" " +document.getElementById(namespace_g + "myForm:itemNotChecked").innerHTML
					+"'><tr><td align='center' tabindex='0'><img id='"+currVolume.identify+"imgID' src='"+img_volume_large + "' alt='"
					+document.getElementById(namespace_g + "myForm:volumeHover").innerHTML+" "+currVolume.name+" "
                    +document.getElementById(namespace_g + "myForm:itemNotChecked").innerHTML+"' title='"
					+document.getElementById(namespace_g + "myForm:volumeHover").innerHTML+" "+currVolume.name+" "
                    +document.getElementById(namespace_g + "myForm:itemNotChecked").innerHTML+"'>"
					+"<BR/><span style='white-space:nowrap' class='dmc_outputText' title='"
					+document.getElementById(namespace_g + "myForm:volumeHover").innerHTML+" "+currVolume.name+"'>"
					+currVolume.name+"</span><BR/><span class='dmc_outputText' style='white-space:nowrap'>"+currVolume.GB+"&nbsp;GB</span></td></tr></table><BR/>";
	}
	volumesSet.innerHTML = strHTML;
}
		
function redrawMappedHostsTab(){
	var mappedHostDiv = document.getElementById("mappedHostsTab");
	var strHTML = "";
		
	var rowNo = 0;
	for(var i=0;i<hostVolMapArray.length;i++){
		var currHost = hostVolMapArray[i].hostItem;
		var currVolumeList = hostVolMapArray[i].volumeItemArray;
		if(0<currVolumeList.length){
			strHTML +="<tr class='"+(0==rowNo%2?"dmc_rowClass1":"dmc_rowClass2")+"'>"
					+"<td align='center' width='24'><input type='checkbox' name='chk' value='"
					+ currHost.identify + "' onclick='clickCheckBox(event)' "
					+" isHost='true' hostIndex='" + i+ "'  alt='"
					+document.getElementById(namespace_g + "myForm:hostHover").innerHTML+" "+currHost.name+"' title='"
					+document.getElementById(namespace_g + "myForm:hostHover").innerHTML+" "+currHost.name+"'></td> "
					+"<td align='left' ><img src='"+img_host_small+"' alt='"
					+document.getElementById(namespace_g + "myForm:hostHover").innerHTML+" "+currHost.name+"' title='"
					+document.getElementById(namespace_g + "myForm:hostHover").innerHTML+" "+currHost.name+"'><span title='"
					+document.getElementById(namespace_g + "myForm:hostHover").innerHTML+" "+currHost.name+"'>"
					+currHost.name+"</span></td><td width='48'>&nbsp;</td><td width='32'>&nbsp;</td></tr>";
			rowNo++;
			for(var j=0;j<currVolumeList.length;j++){
				var currVolume = currVolumeList[j];
				strHTML +="<tr class='"+(0==rowNo%2?"dmc_rowClass1":"dmc_rowClass2")+"'>"
						+"<td align='center'><input type='checkbox' name='chk' value='"
						+currVolume.identify+"'  isHost='false' hostid='"
						+currHost.identify+"' hostIndex='"+i+"' volIndex='"+j+"' onclick='clickCheckBox(event)' alt='"
					    +document.getElementById(namespace_g + "myForm:volumeHover").innerHTML +" "+currVolume.name+"' title='"
					    +document.getElementById(namespace_g + "myForm:volumeHover").innerHTML +" "+currVolume.name+"'></td>"
						+"<td align='left'>&nbsp;&nbsp;&nbsp;&nbsp;<img src='"+img_volume_small+"' alt='"
					    +document.getElementById(namespace_g + "myForm:volumeHover").innerHTML +" "+currVolume.name+"' title='"
					    +document.getElementById(namespace_g + "myForm:volumeHover").innerHTML +" "+currVolume.name+"'><span title='"
						+document.getElementById(namespace_g + "myForm:volumeHover").innerHTML +" "+currVolume.name+"'>"
						+currVolume.name+"</span></td><td  align='left'>"
						+currVolume.GB+"&nbsp;</td><td align='left'>"
						+currVolume.LUN+"&nbsp;</td></tr>";
				rowNo++;
			}
		}
	}
	var tableHTML = mappedHostDiv.innerHTML.removeBetween("<tbody>", "</tbody>");
	mappedHostDiv.innerHTML = tableHTML.insertBefore("</tbody>", strHTML);
}
function doMap(){
	// clear message
	innerMessagesInstance.clearSpecialMessage();
	
	var showAlertBtn = document.getElementById(namespace_g + "myForm:showAlertBtn");	
	
	if(0==selectedHostIDs.length){
		document.getElementById(namespace_g + "myForm:no_host_selected").style.display="";
		document.getElementById(namespace_g + "myForm:no_volume_selected").style.display="none";
		document.getElementById(namespace_g + "myForm:already_mapped").style.display="none";
		document.getElementById(namespace_g + "myForm:maximum_volume_mapped").style.display="none";
		//showAlertBtn.click();
		var message = document.getElementById(namespace_g + "myForm:no_host_selected").innerHTML;
		innerMessagesInstance.showSpecialMessage(message);
		
		return;
	}
	if(0==selectedVolumeIDs.length){
		document.getElementById(namespace_g + "myForm:no_host_selected").style.display="none";
		document.getElementById(namespace_g + "myForm:no_volume_selected").style.display="";
		document.getElementById(namespace_g + "myForm:already_mapped").style.display="none";
		document.getElementById(namespace_g + "myForm:maximum_volume_mapped").style.display="none";
		//showAlertBtn.click();
		var message = document.getElementById(namespace_g + "myForm:no_volume_selected").innerHTML;
		innerMessagesInstance.showSpecialMessage(message);
		
		return;
	}
	
//	if(existMappedVolumeSelected()){
//		document.getElementById(namespace_g + "myForm:no_host_selected").style.display="none";
//		document.getElementById(namespace_g + "myForm:no_volume_selected").style.display="none";
//		document.getElementById(namespace_g + "myForm:already_mapped").style.display="";
//		document.getElementById(namespace_g + "myForm:maximum_volume_mapped").style.display="none";		
		//showAlertBtn.click();
//		var message = document.getElementById(namespace_g + "myForm:already_mapped").innerHTML;
//		innerMessagesInstance.showSpecialMessage(message);
	
//		return;
//	}
	
	if(reachMaximumVolumesPerHost()){
//		document.getElementById("myForm:no_host_selected").style.display="none";
//		document.getElementById("myForm:no_volume_selected").style.display="none";
//		document.getElementById("myForm:already_mapped").style.display="none";
//		document.getElementById("myForm:maximum_volume_mapped").style.display="";
//		
//		var message = document.getElementById("myForm:maximum_volume_mapped").innerHTML;
//		innerMessagesInstance.showSpecialMessage(message);
		document.getElementById("errorMessageLink").innerHTML = genHostsWillExceedLimitation();
		showAlertBtn.click();
//		document.getElementById("errorMessageLink").focus();
		return;
	}
	addVolumesToHostMap();
	redrawMappedHostsTab();
	if(inWizard){
		//HLD updated, after map button clicked, the selected volume will not be removed
		//rmVolFromDefinedVolumeArray();
		redrawVolumesSet(definedVolumeArray);
		selectedVolumeIDs = new Array();
		initVolumeArrayFromHTML();
	}else{
		addVolumesToVolMap();
		rmvVolFromUnmappedList();
		redrawVolumesSet(getCurrVolList());
		selectedVolumeIDs = new Array();
		initVolumeArrayFromHTML();
	}
	selectedHostIDs = new Array();
	selectedHostIndexes = new Array();
	initHostArrayFromHTML();
	changeMapBtnStatus();
	if(!inWizard){
		document.getElementById(namespace_g + "myForm:clickBtn").disabled=false;
	}
}

function existMappedVolumeSelected(){
	for(var n=0;n<selectedHostIndexes.length;n++){
		var currHostMappedVolumes = hostVolMapArray[selectedHostIndexes[n]].volumeItemArray;
		for(var i=0;i<selectedVolumeIDs.length;i++){
			for(var j=0;j<currHostMappedVolumes.length;j++){			
				if(selectedVolumeIDs[i]==currHostMappedVolumes[j].identify){
					return true;
				}
			}
		}
	}
	return false;
}

function reachMaximumVolumesPerHost(){
	for(var n=0;n<selectedHostIndexes.length;n++){
		var selectedHostId = hostArray[selectedHostIndexes[n]].identify;
		var hiddenMappedVolumeNumber = hostVolumeMap.get(selectedHostId);
		var currHostMappedVolumes = hostVolMapArray[selectedHostIndexes[n]].volumeItemArray;
		var selectedVolumeNumber = selectedVolumeIDs.length;
		var mappedVolumeNumber = currHostMappedVolumes.length;
		var total = parseInt(selectedVolumeNumber) + parseInt(mappedVolumeNumber) + parseInt(hiddenMappedVolumeNumber);
		if(total > MAX_VOLUMES_PER_HOST){
			return true;
		}
	}
	return false;
}

function genHostsWillExceedLimitation(){
	var retStr = "<span class='dmc_outputText'>";
	retStr += document.getElementById(namespace_g + "myForm:hostsAlreadyMappedVolumes").innerHTML+"</span><br/>";
	var tempArray = new Array();
	for(var k=0;k<selectedHostIndexes.length;k++){
		tempArray[k]=selectedHostIndexes[k];
	}
	tempArray.sort();
	for(var n=0;n<tempArray.length;n++){
		var selectedHostId = hostArray[tempArray[n]].identify;
		var hiddenMappedVolumeNumber = hostVolumeMap.get(selectedHostId);
		var currHostMappedVolumes = hostVolMapArray[tempArray[n]].volumeItemArray;
		var mappedVolumeNumber = currHostMappedVolumes.length;
		retStr += "&nbsp;&nbsp;&nbsp;<span class='dmc_outputText'>"+hostArray[selectedHostIndexes[n]].name+":&nbsp;"
					+(parseInt(mappedVolumeNumber) + parseInt(hiddenMappedVolumeNumber))
					+"&nbsp;"+document.getElementById(namespace_g + "myForm:volumesLable").innerHTML+"</span><BR/>";
	}
	retStr += "<span class='dmc_outputText'>"+document.getElementById(namespace_g + "myForm:notExceedMaxVolumesLimitation").innerHTML+"</span>";
	return retStr;
}
function addVolumesToHostMap(){
	for (var n = 0; n < selectedHostIndexes.length; n++) {
		var currHostVolMapItem = hostVolMapArray[selectedHostIndexes[n]];
		var currHostMappedVolumes = currHostVolMapItem.volumeItemArray;
		for (var j = 0; j < selectedVolumeIDs.length; j++) {
			if (!currHostVolMapItem.isVolumeMapped(selectedVolumeIDs[j])) {
				for (var i = 0; i < volumeArray.length; i++) {
					if (selectedVolumeIDs[j] == volumeArray[i].identify) {
						aVolume = new Item(volumeArray[i].identify, volumeArray[i].name);
						aVolume.GB = volumeArray[i].GB;
						aVolume.LUN = volumeArray[i].LUN;
						currHostMappedVolumes.push(aVolume);
					}
				}
			}
		}
		currHostVolMapItem.volumeItemArray = currHostMappedVolumes;	
	}
}

function addVolumesToVolMap(){
	for(var n=0;n<selectedHostIndexes.length;n++){
		var currVolMapItem = volMapArray[selectedHostIndexes[n]-0+3];
		var mappedVolArray = currVolMapItem.volumes;
		for(var j=0;j<selectedVolumeIDs.length;j++){
			if (!currVolMapItem.isVolumeMapped(selectedVolumeIDs[j])) {
				for (var i = 0; i < volumeArray.length; i++) {
					if (selectedVolumeIDs[j] == volumeArray[i].identify) {
						aVolume = new Item(volumeArray[i].identify, volumeArray[i].name);
						aVolume.GB = volumeArray[i].GB;
						aVolume.LUN = volumeArray[i].LUN;
						mappedVolArray.push(aVolume);
					}
				}
			}
		}
		volMapArray[selectedHostIndexes[n]-0+3].volumes = mappedVolArray;
	}
}

function rmVolFromDefinedVolumeArray(){
	for(var i=0;i<selectedVolumeIDs.length;i++){
		for(var j=0;j<definedVolumeArray.length;j++){
			if(selectedVolumeIDs[i]==definedVolumeArray[j].identify){
				definedVolumeArray.splice(j,1);
			}
		}
	}
}
function rmvVolFromUnmappedList(){
	var currVolumes = volMapArray[UNMAPPED_VOLUME_TYPE_INDEX].volumes;
	for(var i=0;i<selectedVolumeIDs.length;i++){
		for(var j=0;j<currVolumes.length;j++){
			if(selectedVolumeIDs[i]==currVolumes[j].identify){
				currVolumes.splice(j,1);
			}
		}
	}
	volMapArray[UNMAPPED_VOLUME_TYPE_INDEX].volumes = currVolumes;	
}

function clickCheckBox(thisEvent){
	var unmapBtn = document.getElementById(namespace_g + "myForm:UnmapVolumeBtn");
	
	var chkBoxes = document.forms[namespace_g + "myForm"].chk;//"chk" is the name of the group of checkboxes
	if(null==chkBoxes){//There is no checkbox
		unmapBtn.disabled=true;
		return;
	}

	if(null==chkBoxes.length){//There is only one checkbox.This condition should not happen
		return;
	}
	
	//when clicking the checkbox next to hosts,check/uncheck checkboxes next to the mapped volumes 
	var src = thisEvent.target?thisEvent.target:thisEvent.srcElement;
	var hostIndex = src.attributes.getNamedItem("hostIndex").value;

	

	if("true"==src.attributes.getNamedItem("isHost").value){
		hostVolMapArray[hostIndex].hostItem.selected = src.checked;		
		var mappedVolumes  = hostVolMapArray[hostIndex].volumeItemArray;
		for(var i=0;i<chkBoxes.length;i++){
			if(src == chkBoxes[i]){
				for(var j=0;j<mappedVolumes.length;j++){
					chkBoxes[i+1+j].checked = src.checked;
					mappedVolumes[j].selected = src.checked;
				}
				break;
			}
		}
	}else{
		var volIndex = src.attributes.getNamedItem("volIndex").value;
		hostVolMapArray[hostIndex].volumeItemArray[volIndex].selected = src.checked;
		var mappedHost = hostVolMapArray[hostIndex].hostItem;
		var mappedVolumes  = hostVolMapArray[hostIndex].volumeItemArray;
		var allVolumeUnchecked = true;
		for(var i=0;i<mappedVolumes.length;i++){
			if(mappedVolumes[i].selected){
				allVolumeUnchecked = false;
				break;
			}
		}
		if(allVolumeUnchecked){
			mappedHost.selected = false;
			for(var i=0;i<chkBoxes.length;i++){
				if(mappedHost.identify == chkBoxes[i].value){
					chkBoxes[i].checked=false;
					break;
				}
			}
		}
		
	}
	highlightStartRow('tableBodyTab');
	for(var i=0;i<chkBoxes.length;i++){//There are more than one checkboxes
		if(chkBoxes[i].checked){
			unmapBtn.disabled=false;			
			return;
		}
	}
	unmapBtn.disabled=true;
	return;
}



function doUnmap(){
	// clear message
	innerMessagesInstance.clearSpecialMessage();
	
	var chkBoxes = document.forms[namespace_g + "myForm"].chk;
	if(null==chkBoxes.length){//There is only one checkbox.This condition should not happen
		return;	
	}
	for(var i=0;i<chkBoxes.length;i++){
		if(chkBoxes[i].checked){
			dealOneCheckBox(chkBoxes[i]);
		}
	}
	redrawHostsSet();
	redrawMappedHostsTab();	
	if(inWizard){
		redrawVolumesSet(definedVolumeArray);
	}else{
		redrawVolumesSet(getCurrVolList());
	}
	//clear image selections 
	selectedVolumeIDs = new Array();
	selectedHostIDs = new Array();
	selectedHostIndexes = new Array();
	
	
	//reInit
	initVolumeArrayFromHTML();
	initHostArrayFromHTML();
	changeMapBtnStatus();
	
	//disable the unmap button
	document.getElementById(namespace_g + "myForm:UnmapVolumeBtn").disabled=true;
	if(!inWizard){
		document.getElementById(namespace_g + "myForm:clickBtn").disabled=false;
	}
}

function dealOneCheckBox(chkBoxObj){
	if("true"==chkBoxObj.attributes.getNamedItem("isHost").value){//only one host selected situation will never happen
		return;
		/*
		for(var i=0;i<hostVolMapArray.length;i++){
			if(chkBoxObj.value == hostVolMapArray[i].hostItem.identify){			
				var toUnmapVolumeArray = hostVolMapArray[i].volumeItemArray;
				for(var j=0;j<toUnmapVolumeArray.length;j++){
					if(isVolumeUnmapped(toUnmapVolumeArray[j].identify,chkBoxObj.value)){
						addVolToUnmappedList(toUnmapVolumeArray[j]);
					}
					rmvVolFromVolMap(toUnmapVolumeArray[j].identify,chkBoxObj.attributes.getNamedItem("hostIndex").value);
				}
				hostVolMapArray[i].volumeItemArray = new Array();
			}
		}		
		*/
	}else{
		var origHostID = chkBoxObj.attributes.getNamedItem("hostid").value;
		var hostIndex = chkBoxObj.attributes.getNamedItem("hostIndex").value;
		var volumeID = chkBoxObj.value;
		var currVolume = getVolumeItemFromHostVolMapArray(volumeID,hostIndex);
		
		if(inWizard){
			if(!definedVolumesContain(volumeID)){
				addVolToDefinedVolumeArray(currVolume);
			}
		}else{
			if(isVolumeUnmapped(volumeID,origHostID)){
				addVolToUnmappedList(currVolume);
			}
			rmvVolFromVolMap(volumeID,hostIndex);
		}		
		rmvVolFromHostVolMapArray(volumeID,hostIndex);
	}
}
function definedVolumesContain(volID){
	for(var i=0;i<definedVolumeArray.length;i++){
		if(volID==definedVolumeArray[i].identify){
			return true;
		}
	}
	return false;
}
function isVolumeUnmapped(volID,origHostID){
	for(var i=0;i<hostVolMapArray.length;i++){
		if(origHostID == hostVolMapArray[i].hostItem.identify){
			continue;
		}
		var currVolumeArray = hostVolMapArray[i].volumeItemArray;
		for(var j=0;j<currVolumeArray.length;j++){
			if(volID==currVolumeArray[j].identify){
				return false;
			}
		}
	}
	return true;
}
function addVolToDefinedVolumeArray(volItem){
	definedVolumeArray.push(volItem);
}
function addVolToUnmappedList(volItem){
	volMapArray[1].volumes.push(volItem);	
}

function getVolumeItemFromHostVolMapArray(volID,hostIndex){
	var currVolumes = hostVolMapArray[hostIndex].volumeItemArray;	
	for(var i=0;i<currVolumes.length;i++){
		if(volID==currVolumes[i].identify){
			return currVolumes[i];
		}
	}	
}

function rmvVolFromVolMap(volID,hostIndex){
	var currVolumes = volMapArray[hostIndex-0+3].volumes;	
	for(var i=0;i<currVolumes.length;i++){
		if(volID==currVolumes[i].identify){
			currVolumes.splice(i,1);
			break;
		}
	}	
	volMapArray[hostIndex-0+3].volumes = currVolumes;
}

function rmvVolFromHostVolMapArray(volID,hostIndex){
	var currVolumes = hostVolMapArray[hostIndex].volumeItemArray;	
	for(var i=0;i<currVolumes.length;i++){
		if(volID==currVolumes[i].identify){
			currVolumes.splice(i,1);
			break;
		}
	}	
	hostVolMapArray[hostIndex].volumeItemArray = currVolumes;
}
function disableButtons(){
	document.getElementById(namespace_g + "myForm:discoverHostBtn").disabled=true;
	document.getElementById(namespace_g + "myForm:mapVolumeBtn").disabled=true;
	document.getElementById(namespace_g + "myForm:UnmapVolumeBtn").disabled=true;
	if(!inWizard){
		document.getElementById(namespace_g + "myForm:clickBtn").disabled=true;
		document.getElementById(namespace_g + "myForm:closeBtn").disabled=true;
	}
}
function genHostArrayStr(){
	var str = "";
	for(var i=0;i<hostVolMapArray.length;i++){
		var currHost = hostVolMapArray[i].hostItem;
		var currVolumeArray = hostVolMapArray[i].volumeItemArray;
		str += currHost.identify+"(";
		if(currVolumeArray.length >1){
			for(var j=0;j<currVolumeArray.length-1;j++){
				var currVolume = currVolumeArray[j];
				str += currVolume.identify +",";
			}
			str += currVolumeArray[currVolumeArray.length-1].identify;
		}else if(currVolumeArray.length == 1){
			str += currVolumeArray[0].identify;
		}
		str += ")|";			
	}
	return str;
}
	
function newXMLHttpRequest() 
{
  var xmlreq = false;
  if (window.XMLHttpRequest) 
  {
    // Create XMLHttpRequest object in non-Microsoft browsers
    xmlreq = new XMLHttpRequest();
  }
  else if (window.ActiveXObject)
  {
    // Create XMLHttpRequest via MS ActiveX
    try 
    {
      // Try to create XMLHttpRequest in later versions
      // of Internet Explorer
      xmlreq = new ActiveXObject("Msxml2.XMLHTTP");
    }
    catch (e1) 
    {
      // Failed to create required ActiveXObject
      try
      {
        // Try version supported by older versions
        // of Internet Explorer
        xmlreq = new ActiveXObject("Microsoft.XMLHTTP");
      } 
      catch (e2) 
      {
        // Unable to create an XMLHttpRequest with ActiveX
      }
    }
  }
  return xmlreq;
}

function checkPrecondition(){
	var inner_message = document.getElementById("inner_message");	
	var hosts_progress_div = document.getElementById("hosts_progress_div");	
	var volFilter_progress_div = document.getElementById("volFilter_progress_div");	
	var volumes_progress_div = document.getElementById("volumes_progress_div");	
	var mappedHosts_progress_div = document.getElementById("mappedHosts_progress_div");	

	var okBtn = document.getElementById(namespace_g + "myForm:OkButton");	
	var mapVolumeBtn = document.getElementById(namespace_g + "myForm:mapVolumeBtn");
	var discoverHostBtn=document.getElementById(namespace_g + "myForm:discoverHostBtn");
	var checkpassed = true;
	var selectedHostMaxVols = document.getElementById(namespace_g + "myForm:selectedHostMaxVols").innerHTML;
	var volumeavailable = document.getElementById(namespace_g + "myForm:volumeAvailable").innerHTML;	
	var allHostsMaxVols = document.getElementById(namespace_g + "myForm:allHostsMaxVols").innerHTML;
	//alert("selectedHostMaxVols["+selectedHostMaxVols+"]");
	//alert("volume available["+volumeavailable+"]");
	//alert("allHostsMaxVols["+allHostsMaxVols+"]");
	if("true"==selectedHostMaxVols){
		checkpassed = false;
		document.getElementById("infoImag").style.display="";
		document.getElementById("errorImag").style.display="none";
		document.getElementById(namespace_g + "myForm:MapVolumes_maximum_volume").style.display="";
		document.getElementById(namespace_g + "myForm:MapVolumes_no_volume").style.display="none";
		document.getElementById(namespace_g + "myForm:MapVolumes_All_Hosts_maximum_volume").style.display="none";
	}else if("true"==allHostsMaxVols){
		checkpassed = false;
		document.getElementById("infoImag").style.display="";
		document.getElementById("errorImag").style.display="none";
		document.getElementById(namespace_g + "myForm:MapVolumes_maximum_volume").style.display="none";
		document.getElementById(namespace_g + "myForm:MapVolumes_no_volume").style.display="none";
		document.getElementById(namespace_g + "myForm:MapVolumes_All_Hosts_maximum_volume").style.display="";
	}else if("false"==volumeavailable){
		checkpassed = false;
		document.getElementById("infoImag").style.display="";
		document.getElementById("errorImag").style.display="none";
		document.getElementById(namespace_g + "myForm:MapVolumes_maximum_volume").style.display="none";
		document.getElementById(namespace_g + "myForm:MapVolumes_no_volume").style.display="";
		document.getElementById(namespace_g + "myForm:MapVolumes_All_Hosts_maximum_volume").style.display="none";
	}
	if(!checkpassed){
		inner_message.style.display="";
		hosts_progress_div.style.display = "none";
		volFilter_progress_div.style.display = "none";
		volumes_progress_div.style.display = "none";
		mappedHosts_progress_div.style.display = "none";
		mapVolumeBtn.disabled = true;
		discoverHostBtn.disabled = true;
		document.getElementById("main_progress_div").innerHTML="";
		document.getElementById("main_progress_div").style.height = "280";
		if(!inWizard){			
			document.getElementById("step1columne").style.height="240";	
			document.getElementById("hostsSet").style.height="210";		
			document.getElementById("step2columne").style.height="240";		
			document.getElementById("volumesSet").style.height="210";		
			document.getElementById("step3columne").style.height="240";		
			document.getElementById("step3columneSubtab").style.height="210";	
			document.getElementById("mappedHostsTab").style.height="180";				
			document.getElementById("main_mapVolume_tab").style.height="270";
		}else{
			document.getElementById("step1columne").style.height="290";	
			document.getElementById("hostsSet").style.height="260";		
			document.getElementById("step2columne").style.height="290";		
			document.getElementById("volumesSet").style.height="290";		
			document.getElementById("step3columne").style.height="290";		
			document.getElementById("step3columneSubtab").style.height="260";	
			document.getElementById("mappedHostsTab").style.height="230";				
			document.getElementById("main_mapVolume_tab").style.height="320";	
			//If in wizard, can do next.
			mapVolumeBtn.disabled = false;
		}
	}
	return checkpassed;
}

function onLoad_MapVolumes(){
	document.getElementById("progressDiv").style.display = "none";
	if("true"==document.getElementById(namespace_g + "myForm:inWizardFlag").innerHTML){
		document.getElementsByTagName("body")[0].className = "wizardFrameBody";
		document.getElementById("wizardTitle").style.display="";
		document.getElementById("filterRow").style.display="none";
		document.getElementById("volumesSet").style.height=270;
		document.getElementById(namespace_g + "myForm:discoverHostBtn").onclick=function (){setDiscoverTarget(600,395);};
		resetTablesHeight();
		parent.refreshNext();
	}else{
		document.getElementById("wizardTitle").style.display="none";
		document.getElementById(namespace_g + "myForm:discoverHostBtn").onclick= function () {setFormTargetFromMap(600,380);};
	}
	req = newXMLHttpRequest();
	req.onreadystatechange = populateData;

	// Open connection
	var urlbasepath = document.getElementsByTagName("Base")[0].href;
	var url = urlbasepath+"faces/page/rbce/storage/LoadMapVolumeData.jsp";
	req.open("GET",url, true);
	req.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	// Send data
	req.send(null);
	
	// initial error message	
    initErrorMessage();
}		

function enableIndicator(flag){
	if(flag){
		document.getElementById(namespace_g + "myForm:main_refreshing_txt").innerHTML=document.getElementById(namespace_g + "myForm:waitingMappingTxt").innerHTML;
		document.getElementById("hostsSet").style.display="none";
		document.getElementById("volumesSet").style.display="none";
		document.getElementById("mappedHostsTab").style.display="none";
		document.getElementById("hosts_progress_div").style.display="";
		document.getElementById("volumes_progress_div").style.display="";
		document.getElementById("mappedHosts_progress_div").style.display="";
		document.getElementById("main_mapVolume_tab").style.display="none";
		document.getElementById("main_progress_div").style.display="";
	}else{
		document.getElementById("hostsSet").style.display="";
		document.getElementById("volumesSet").style.display="";
		document.getElementById("mappedHostsTab").style.display="";
		document.getElementById("hosts_progress_div").style.display="none";
		document.getElementById("volumes_progress_div").style.display="none";
		document.getElementById("mappedHosts_progress_div").style.display="none";
		document.getElementById("main_mapVolume_tab").style.display="";
		document.getElementById("main_progress_div").style.display="none";
	}
}
function populateData(){
	if(req.readyState == 4){
		if(req.status && req.status == 200){
			var txt = req.responseText;
			//var xml = req.responseXML;	

			eval(txt);
			if(checkPrecondition()){					
				
				redrawHostsSet();
				initHostArrayFromHTML();
				redrawMappedHostsTab();
				//clear selectedVolumeIds array
				selectedVolumeIDs = new Array();
				
				if(inWizard){
					document.getElementsByTagName("body")[0].className = "wizardFrameBody";
					document.getElementById("wizardTitle").style.display="";
					document.getElementById(namespace_g + "myForm:discoverHostBtn").onclick=function (){setDiscoverTarget(600,395);};
					redrawVolumesSet(definedVolumeArray);		
					resetTablesHeight();	
					narrowVolumeColumn();		
				}else{
					if("FROM_VOLUMES_TAB"==document.getElementById(namespace_g + "myForm:loadFrom").innerHTML){
						document.getElementById("filterRow").style.display="none";
						document.getElementById("volumesSet").style.height=270;
					}else{
						document.getElementById("filterRow").style.display="";
					}
					document.getElementById("wizardTitle").style.display="none";
					document.getElementById(namespace_g + "myForm:discoverHostBtn").onclick= function () {
						setFormTargetFromMap(600,380);
						parent.document.getElementById(parent.namespace_g + "myForm:util_dialog_sec_level_tb").lastChild.nodeValue = document.getElementById(namespace_g + "myForm:discoverTitleString").innerHTML;
					};
					genVolumeFilterOptions();
										
					redrawVolumesSet(getCurrVolList());	
					if(""!=preSelectedHostID&&1<hostArray.length){
						document.getElementById(preSelectedHostID).onclick();	
					}			
					document.getElementById(namespace_g + "myForm:clickBtn").disabled = false;	
				}
				//reInit volumeArray
				initVolumeArrayFromHTML();
				dispPage();							
				document.getElementById("progressDiv").style.display = "block";
				document.getElementById(namespace_g + "myForm:originHostArrayStr").innerHTML = genHostArrayStr();
			}else{
				if(!inWizard){
					document.getElementById(namespace_g + "myForm:clickBtn").disabled = true;
				}
		    }
			parent.stopWait("util_dialog");
			alignHeaderTableAndContentTable('headerTableDivId','tableBodyTab');			
		}    
	}
}

function resetTablesHeight(){
	document.getElementById("step1columne").style.height="310";	
	document.getElementById("hostsSet").style.height="280";		
	document.getElementById("step2columne").style.height="310";		
	document.getElementById("volumesSet").style.height="310";		
	document.getElementById("step3columne").style.height="310";		
	document.getElementById("step3columneSubtab").style.height="280";	
	document.getElementById("mappedHostsTab").style.height="250";				
	document.getElementById("main_mapVolume_tab").style.height="340";
	document.getElementById("button_table").style.display="none";
}
function resetTablesHeightOnError(){
	document.getElementById("step1columne").style.height="220";	
	document.getElementById("hostsSet").style.height="190";		
	document.getElementById("step2columne").style.height="220";		
	document.getElementById("volumesSet").style.height="190";		
	document.getElementById("step3columne").style.height="220";		
	document.getElementById("step3columneSubtab").style.height="190";	
	document.getElementById("mappedHostsTab").style.height="160";				
	document.getElementById("main_mapVolume_tab").style.height="250";
}

function dispPage(){
	document.getElementById("hostsSet").style.display="";
	document.getElementById("hosts_progress_div").style.display="none";
	document.getElementById("volumeFilter").style.display="";
	document.getElementById("volFilter_progress_div").style.display="none";
	document.getElementById("volumesSet").style.display="";
	document.getElementById("volumes_progress_div").style.display="none";
	document.getElementById("mappedHostsTab").style.display="";
	document.getElementById("mappedHosts_progress_div").style.display="none";
	document.getElementById("main_mapVolume_tab").style.display="";
	document.getElementById("main_progress_div").style.display="none";
}

function narrowVolumeColumn(){
	document.getElementById("step2columne").style.width="150";
	document.getElementById("volumesSet").style.width="150";
}

function highlightStartRow(tableId)
{
	var elmt = document.getElementById(tableId);
	if(elmt==null)
		return;
	var tbody = elmt.getElementsByTagName("tbody");
	if(tbody==null || tbody.length==0)
		return;
	trs = tbody[0].getElementsByTagName("tr");
	for(var i=0;i<trs.length;i++){
	   var node = trs[i];
	  while(node){
		 node = node.childNodes[0];	
		 if(node.tagName)
		    if(node.tagName=="INPUT")
		    	break;
	  }
	  if(node.tagName=="INPUT" && node.checked)
			trs[i].className="dmc_rowHightLightClass";
	  else{
		  if(i%2==0)
		    trs[i].className="dmc_rowClass1";
		   else
		    trs[i].className="dmc_rowClass2";    
		}
	}
}

function cancleClick(){
	parent.closeUtilDialog();
	var finishFlag = document.getElementById(namespace_g + "myForm:finishFlag");
	if(finishFlag && "true"== finishFlag.innerHTML){
		parent.refreshAllTabs(parent.REFRESH_MASK_VOLUME+parent.REFRESH_MASK_HOST);
	}
}

function setDiscoverTarget(varwidth, vareight){
	document.getElementById(namespace_g + "myForm").target="templ_u_iframe_discover_dialog";
	document.getElementById(namespace_g + 'myForm:util_dialog_discover_launcher').click();
	adjustDialogSizeFromMapWizard(varwidth,vareight);
}

function setDiscoverDialogTitle(){
	document.getElementById(namespace_g + "myForm:discover_dialog_tb").lastChild.nodeValue = document.getElementById(namespace_g + "myForm:discoverTitleString").innerHTML;	
}
function closeDiscoverDialog(){
		var iframe = document.getElementById("templ_u_iframe_discover_dialog");
		if(!iframe){
			var iframe = parent.document.getElementById("templ_u_iframe_discover_dialog");		
		}
		if(iframe){
			iframe.src="";
			iframe.style.height="1px";
		}
		document.getElementById(namespace_g + 'myForm:util_dialog_discover_closer').click();
		
}

function submitForm() {
	document.getElementById(namespace_g + "myForm:OkButton").click();
}
function onDialogHide(thisObj,thisEvent){
	var width = document.body.clientWidth;
	var height = document.body.clientHeight;
	
	var objWidth = thisObj.clientWidth;
	var objHeight = thisObj.clientHeight;
	
	if(width>objWidth && height>objHeight){
		var top = height/2 - objHeight/2;
		var left = width/2 - objWidth/2;
		thisObj.style.top = top;
		thisObj.style.left = left;	
		
	}else if(width>objWidth && height<objHeight){
		var left = width/2 - objWidth/2;
		thisObj.style.top = 25;
		thisObj.style.left = left;	
	
	}else if(width<objWidth && height>objHeight){
		var top = height/2 - objHeight/2;
		thisObj.style.top = top;
		thisObj.style.left = 25;		
	}else{
		thisObj.style.top = 25;
		thisObj.style.left = 25;	
	}
}

function getAbsoulteX(htmlElement)
{
	absoluteX = 0;	 
	while(htmlElement) 
	{
		absoluteX += htmlElement.offsetLeft;
		htmlElement = htmlElement.offsetParent;
	}	
	return absoluteX;
}

function getAbsoulteY(htmlElement)
{
	absoluteY = 0;
	while(htmlElement) 
	{
		absoluteY += htmlElement.offsetTop;
		htmlElement = htmlElement.offsetParent;
	}	
	return absoluteY;   
}

function lazyLoad() {
	document.getElementById(namespace_g + "myForm:refreshProgressBtn").click();
}

function checkTask() {
	document.getElementById("progressDiv").style.display = "block";
	var finishFlag = document.getElementById(namespace_g + "myForm:finishFlag");
	
	if (finishFlag && finishFlag.innerHTML == "false") {
		setTimeout(lazyLoad , 1000);
	} else {
		document.getElementById(namespace_g + 'myForm:errorOccured').innerHTML = document.getElementById(namespace_g + 'myForm:innerMsgDisplay').innerHTML;
		document.getElementById(namespace_g + 'myForm:main_refreshing_img').style.display = "none";
		document.getElementById(namespace_g + 'myForm:main_refreshing_txt').style.display = "none";
		if("true"==document.getElementById(namespace_g + 'myForm:errorOccured').innerHTML){
			document.getElementById(namespace_g + "myForm:status_error").style.display="";
		}else{
			document.getElementById(namespace_g + "myForm:status_success").style.display="";
		}
		document.getElementById(namespace_g + "myForm:clearSessionBtn").click();
		beepWhenRefresh();
	}
}

function checkStatus(){
	document.getElementById("progressDiv").style.display = "block";
	if("true"!=document.getElementById(namespace_g + 'myForm:errorOccured').innerHTML){
		document.getElementById(namespace_g + "myForm:finishFlag").innerHTML="true";
		cancleClick();
	}else{
		resetTablesHeightOnError();
		document.getElementById(namespace_g + 'myForm:closeBtn').disabled = false;
	}
	innerMessagesInstance.display();
}

function onOkButtonClick(){
	document.getElementById(namespace_g + "myForm:newHostArrayStr").value = genHostArrayStr();
	
	var newHostArrayStr = document.getElementById(namespace_g + "myForm:newHostArrayStr").value;
	var originHostArrayStr = document.getElementById(namespace_g + "myForm:originHostArrayStr").innerHTML;
	if(newHostArrayStr == originHostArrayStr){
		document.getElementById("errorMessageLink").innerHTML = "<span class='dmc_outputText'>"+document.getElementById(namespace_g + "myForm:no_mapping_changed").innerHTML+"</span>";
		document.getElementById(namespace_g + "myForm:showAlertBtn").click();
		return false;
	}else{
		disableButtons();
		enableIndicator(true);
		document.getElementById("progressDiv").style.display = "block";
		document.getElementById(namespace_g + "myForm:hiddenClickBtn").click();
		return true;
	}
}

function wizardOkButtonClick(){
	document.getElementById(namespace_g + "myForm").target='_parent';
	document.getElementById(namespace_g + "myForm:newHostArrayStr").value = genHostArrayStr();
}
